// Generated by rstantools.  Do not edit by hand.

/*
    Test is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Test is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Test.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef MODELS_HPP
#define MODELS_HPP
#define STAN__SERVICES__COMMAND_HPP
#ifndef USE_STANC3
#define USE_STANC3
#endif
#include <rstan/rstaninc.hpp>
// Code generated by stanc v2.32.2
#include <stan/model/model_header.hpp>
namespace model_fs_namespace {
using stan::model::model_base_crtp;
using namespace stan::math;
stan::math::profile_map profiles__;
static constexpr std::array<const char*, 32> locations_array__ =
  {" (found before start of program)",
  " (in 'fs', line 18, column 1 to column 17)",
  " (in 'fs', line 19, column 1 to column 36)",
  " (in 'fs', line 20, column 1 to column 18)",
  " (in 'fs', line 23, column 1 to column 26)",
  " (in 'fs', line 37, column 2 to column 23)",
  " (in 'fs', line 27, column 4 to column 44)",
  " (in 'fs', line 26, column 9 to line 28, column 3)",
  " (in 'fs', line 25, column 4 to column 48)",
  " (in 'fs', line 24, column 21 to line 26, column 3)",
  " (in 'fs', line 24, column 2 to line 28, column 3)",
  " (in 'fs', line 39, column 4 to column 50)",
  " (in 'fs', line 38, column 20 to line 40, column 3)",
  " (in 'fs', line 38, column 2 to line 40, column 3)",
  " (in 'fs', line 31, column 1 to column 27)",
  " (in 'fs', line 32, column 2 to column 21)",
  " (in 'fs', line 33, column 2 to column 20)",
  " (in 'fs', line 34, column 2 to column 23)",
  " (in 'fs', line 9, column 1 to column 20)",
  " (in 'fs', line 10, column 8 to column 12)",
  " (in 'fs', line 10, column 1 to column 17)",
  " (in 'fs', line 11, column 8 to column 12)",
  " (in 'fs', line 11, column 1 to column 20)",
  " (in 'fs', line 12, column 1 to column 21)",
  " (in 'fs', line 13, column 2 to column 33)",
  " (in 'fs', line 14, column 2 to column 18)",
  " (in 'fs', line 15, column 2 to column 19)",
  " (in 'fs', line 18, column 8 to column 12)",
  " (in 'fs', line 19, column 26 to column 30)",
  " (in 'fs', line 20, column 8 to column 12)",
  " (in 'fs', line 23, column 17 to column 21)",
  " (in 'fs', line 37, column 9 to column 13)"};
#include <stan_meta_header.hpp>
class model_fs final : public model_base_crtp<model_fs> {
private:
  int SIZE;
  Eigen::Matrix<double,-1,1> Y_data__;
  Eigen::Matrix<double,-1,1> SIGY_data__;
  double DELTA;
  int PRIORSIG;
  double B;
  double MU;
  Eigen::Map<Eigen::Matrix<double,-1,1>> Y{nullptr, 0};
  Eigen::Map<Eigen::Matrix<double,-1,1>> SIGY{nullptr, 0};
public:
  ~model_fs() {}
  model_fs(stan::io::var_context& context__, unsigned int random_seed__ = 0,
           std::ostream* pstream__ = nullptr) : model_base_crtp(0) {
    int current_statement__ = 0;
    using local_scalar_t__ = double;
    boost::ecuyer1988 base_rng__ =
      stan::services::util::create_rng(random_seed__, 0);
    // suppress unused var warning
    (void) base_rng__;
    static constexpr const char* function__ = "model_fs_namespace::model_fs";
    // suppress unused var warning
    (void) function__;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    try {
      int pos__ = std::numeric_limits<int>::min();
      pos__ = 1;
      current_statement__ = 18;
      context__.validate_dims("data initialization", "SIZE", "int",
        std::vector<size_t>{});
      SIZE = std::numeric_limits<int>::min();
      current_statement__ = 18;
      SIZE = context__.vals_i("SIZE")[(1 - 1)];
      current_statement__ = 18;
      stan::math::check_greater_or_equal(function__, "SIZE", SIZE, 0);
      current_statement__ = 19;
      stan::math::validate_non_negative_index("Y", "SIZE", SIZE);
      current_statement__ = 20;
      context__.validate_dims("data initialization", "Y", "double",
        std::vector<size_t>{static_cast<size_t>(SIZE)});
      Y_data__ = Eigen::Matrix<double,-1,1>::Constant(SIZE,
                   std::numeric_limits<double>::quiet_NaN());
      new (&Y) Eigen::Map<Eigen::Matrix<double,-1,1>>(Y_data__.data(), SIZE);
      {
        std::vector<local_scalar_t__> Y_flat__;
        current_statement__ = 20;
        Y_flat__ = context__.vals_r("Y");
        current_statement__ = 20;
        pos__ = 1;
        current_statement__ = 20;
        for (int sym1__ = 1; sym1__ <= SIZE; ++sym1__) {
          current_statement__ = 20;
          stan::model::assign(Y, Y_flat__[(pos__ - 1)],
            "assigning variable Y", stan::model::index_uni(sym1__));
          current_statement__ = 20;
          pos__ = (pos__ + 1);
        }
      }
      current_statement__ = 21;
      stan::math::validate_non_negative_index("SIGY", "SIZE", SIZE);
      current_statement__ = 22;
      context__.validate_dims("data initialization", "SIGY", "double",
        std::vector<size_t>{static_cast<size_t>(SIZE)});
      SIGY_data__ = Eigen::Matrix<double,-1,1>::Constant(SIZE,
                      std::numeric_limits<double>::quiet_NaN());
      new (&SIGY) Eigen::Map<Eigen::Matrix<double,-1,1>>(SIGY_data__.data(),
        SIZE);
      {
        std::vector<local_scalar_t__> SIGY_flat__;
        current_statement__ = 22;
        SIGY_flat__ = context__.vals_r("SIGY");
        current_statement__ = 22;
        pos__ = 1;
        current_statement__ = 22;
        for (int sym1__ = 1; sym1__ <= SIZE; ++sym1__) {
          current_statement__ = 22;
          stan::model::assign(SIGY, SIGY_flat__[(pos__ - 1)],
            "assigning variable SIGY", stan::model::index_uni(sym1__));
          current_statement__ = 22;
          pos__ = (pos__ + 1);
        }
      }
      current_statement__ = 23;
      context__.validate_dims("data initialization", "DELTA", "double",
        std::vector<size_t>{});
      DELTA = std::numeric_limits<double>::quiet_NaN();
      current_statement__ = 23;
      DELTA = context__.vals_r("DELTA")[(1 - 1)];
      current_statement__ = 23;
      stan::math::check_greater_or_equal(function__, "DELTA", DELTA, 0);
      current_statement__ = 24;
      context__.validate_dims("data initialization", "PRIORSIG", "int",
        std::vector<size_t>{});
      PRIORSIG = std::numeric_limits<int>::min();
      current_statement__ = 24;
      PRIORSIG = context__.vals_i("PRIORSIG")[(1 - 1)];
      current_statement__ = 24;
      stan::math::check_greater_or_equal(function__, "PRIORSIG", PRIORSIG, 0);
      current_statement__ = 24;
      stan::math::check_less_or_equal(function__, "PRIORSIG", PRIORSIG, 1);
      current_statement__ = 25;
      context__.validate_dims("data initialization", "B", "double",
        std::vector<size_t>{});
      B = std::numeric_limits<double>::quiet_NaN();
      current_statement__ = 25;
      B = context__.vals_r("B")[(1 - 1)];
      current_statement__ = 25;
      stan::math::check_greater_or_equal(function__, "B", B, 0);
      current_statement__ = 26;
      context__.validate_dims("data initialization", "MU", "double",
        std::vector<size_t>{});
      MU = std::numeric_limits<double>::quiet_NaN();
      current_statement__ = 26;
      MU = context__.vals_r("MU")[(1 - 1)];
      current_statement__ = 27;
      stan::math::validate_non_negative_index("mu", "SIZE", SIZE);
      current_statement__ = 28;
      stan::math::validate_non_negative_index("uvs", "SIZE", SIZE);
      current_statement__ = 29;
      stan::math::validate_non_negative_index("nvs", "SIZE", SIZE);
      current_statement__ = 30;
      stan::math::validate_non_negative_index("vs", "SIZE", SIZE);
      current_statement__ = 31;
      stan::math::validate_non_negative_index("log_lik", "SIZE", SIZE);
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
    num_params_r__ = SIZE + SIZE + SIZE;
  }
  inline std::string model_name() const final {
    return "model_fs";
  }
  inline std::vector<std::string> model_compile_info() const noexcept {
    return std::vector<std::string>{"stanc_version = stanc3 v2.32.2",
             "stancflags = --allow-undefined"};
  }
  template <bool propto__, bool jacobian__, typename VecR, typename VecI,
            stan::require_vector_like_t<VecR>* = nullptr,
            stan::require_vector_like_vt<std::is_integral, VecI>* = nullptr>
  inline stan::scalar_type_t<VecR>
  log_prob_impl(VecR& params_r__, VecI& params_i__, std::ostream*
                pstream__ = nullptr) const {
    using T__ = stan::scalar_type_t<VecR>;
    using local_scalar_t__ = T__;
    T__ lp__(0.0);
    stan::math::accumulator<T__> lp_accum__;
    stan::io::deserializer<local_scalar_t__> in__(params_r__, params_i__);
    int current_statement__ = 0;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    static constexpr const char* function__ = "model_fs_namespace::log_prob";
    // suppress unused var warning
    (void) function__;
    try {
      Eigen::Matrix<local_scalar_t__,-1,1> mu =
        Eigen::Matrix<local_scalar_t__,-1,1>::Constant(SIZE, DUMMY_VAR__);
      current_statement__ = 1;
      mu = in__.template read<Eigen::Matrix<local_scalar_t__,-1,1>>(SIZE);
      Eigen::Matrix<local_scalar_t__,-1,1> uvs =
        Eigen::Matrix<local_scalar_t__,-1,1>::Constant(SIZE, DUMMY_VAR__);
      current_statement__ = 2;
      uvs = in__.template read_constrain_lub<
              Eigen::Matrix<local_scalar_t__,-1,1>, jacobian__>(0, 1, lp__,
              SIZE);
      Eigen::Matrix<local_scalar_t__,-1,1> nvs =
        Eigen::Matrix<local_scalar_t__,-1,1>::Constant(SIZE, DUMMY_VAR__);
      current_statement__ = 3;
      nvs = in__.template read<Eigen::Matrix<local_scalar_t__,-1,1>>(SIZE);
      Eigen::Matrix<local_scalar_t__,-1,1> vs =
        Eigen::Matrix<local_scalar_t__,-1,1>::Constant(SIZE, DUMMY_VAR__);
      current_statement__ = 10;
      if (stan::math::logical_eq(0, PRIORSIG)) {
        current_statement__ = 8;
        stan::model::assign(vs,
          stan::math::exp(
            stan::math::add(stan::math::log(SIGY),
              stan::math::multiply(
                stan::math::subtract(stan::math::multiply(uvs, 2), 1), DELTA))),
          "assigning variable vs");
      } else {
        current_statement__ = 6;
        stan::model::assign(vs,
          stan::math::exp(
            stan::math::add(stan::math::log(SIGY),
              stan::math::multiply(nvs, stan::math::sqrt(DELTA)))),
          "assigning variable vs");
      }
      current_statement__ = 4;
      stan::math::check_greater_or_equal(function__, "vs", vs, 0);
      {
        current_statement__ = 14;
        lp_accum__.add(stan::math::normal_lpdf<propto__>(mu, MU,
                         stan::math::sqrt(B)));
        current_statement__ = 15;
        lp_accum__.add(stan::math::uniform_lpdf<propto__>(uvs, 0, 1));
        current_statement__ = 16;
        lp_accum__.add(stan::math::normal_lpdf<propto__>(nvs, 0, 1));
        current_statement__ = 17;
        lp_accum__.add(stan::math::normal_lpdf<propto__>(Y, mu, vs));
      }
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
    lp_accum__.add(lp__);
    return lp_accum__.sum();
  }
  template <typename RNG, typename VecR, typename VecI, typename VecVar,
            stan::require_vector_like_vt<std::is_floating_point,
            VecR>* = nullptr, stan::require_vector_like_vt<std::is_integral,
            VecI>* = nullptr, stan::require_vector_vt<std::is_floating_point,
            VecVar>* = nullptr>
  inline void
  write_array_impl(RNG& base_rng__, VecR& params_r__, VecI& params_i__,
                   VecVar& vars__, const bool
                   emit_transformed_parameters__ = true, const bool
                   emit_generated_quantities__ = true, std::ostream*
                   pstream__ = nullptr) const {
    using local_scalar_t__ = double;
    stan::io::deserializer<local_scalar_t__> in__(params_r__, params_i__);
    stan::io::serializer<local_scalar_t__> out__(vars__);
    static constexpr bool propto__ = true;
    // suppress unused var warning
    (void) propto__;
    double lp__ = 0.0;
    // suppress unused var warning
    (void) lp__;
    int current_statement__ = 0;
    stan::math::accumulator<double> lp_accum__;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    constexpr bool jacobian__ = false;
    static constexpr const char* function__ =
      "model_fs_namespace::write_array";
    // suppress unused var warning
    (void) function__;
    try {
      Eigen::Matrix<double,-1,1> mu =
        Eigen::Matrix<double,-1,1>::Constant(SIZE,
          std::numeric_limits<double>::quiet_NaN());
      current_statement__ = 1;
      mu = in__.template read<Eigen::Matrix<local_scalar_t__,-1,1>>(SIZE);
      Eigen::Matrix<double,-1,1> uvs =
        Eigen::Matrix<double,-1,1>::Constant(SIZE,
          std::numeric_limits<double>::quiet_NaN());
      current_statement__ = 2;
      uvs = in__.template read_constrain_lub<
              Eigen::Matrix<local_scalar_t__,-1,1>, jacobian__>(0, 1, lp__,
              SIZE);
      Eigen::Matrix<double,-1,1> nvs =
        Eigen::Matrix<double,-1,1>::Constant(SIZE,
          std::numeric_limits<double>::quiet_NaN());
      current_statement__ = 3;
      nvs = in__.template read<Eigen::Matrix<local_scalar_t__,-1,1>>(SIZE);
      Eigen::Matrix<double,-1,1> vs =
        Eigen::Matrix<double,-1,1>::Constant(SIZE,
          std::numeric_limits<double>::quiet_NaN());
      out__.write(mu);
      out__.write(uvs);
      out__.write(nvs);
      if (stan::math::logical_negation(
            (stan::math::primitive_value(emit_transformed_parameters__) ||
            stan::math::primitive_value(emit_generated_quantities__)))) {
        return ;
      }
      current_statement__ = 10;
      if (stan::math::logical_eq(0, PRIORSIG)) {
        current_statement__ = 8;
        stan::model::assign(vs,
          stan::math::exp(
            stan::math::add(stan::math::log(SIGY),
              stan::math::multiply(
                stan::math::subtract(stan::math::multiply(uvs, 2), 1), DELTA))),
          "assigning variable vs");
      } else {
        current_statement__ = 6;
        stan::model::assign(vs,
          stan::math::exp(
            stan::math::add(stan::math::log(SIGY),
              stan::math::multiply(nvs, stan::math::sqrt(DELTA)))),
          "assigning variable vs");
      }
      current_statement__ = 4;
      stan::math::check_greater_or_equal(function__, "vs", vs, 0);
      if (emit_transformed_parameters__) {
        out__.write(vs);
      }
      if (stan::math::logical_negation(emit_generated_quantities__)) {
        return ;
      }
      Eigen::Matrix<double,-1,1> log_lik =
        Eigen::Matrix<double,-1,1>::Constant(SIZE,
          std::numeric_limits<double>::quiet_NaN());
      current_statement__ = 13;
      for (int i = 1; i <= SIZE; ++i) {
        current_statement__ = 11;
        stan::model::assign(log_lik,
          stan::math::normal_lpdf<false>(
            stan::model::rvalue(Y, "Y", stan::model::index_uni(i)),
            stan::model::rvalue(mu, "mu", stan::model::index_uni(i)),
            stan::model::rvalue(vs, "vs", stan::model::index_uni(i))),
          "assigning variable log_lik", stan::model::index_uni(i));
      }
      out__.write(log_lik);
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
  }
  template <typename VecVar, typename VecI,
            stan::require_vector_t<VecVar>* = nullptr,
            stan::require_vector_like_vt<std::is_integral, VecI>* = nullptr>
  inline void
  unconstrain_array_impl(const VecVar& params_r__, const VecI& params_i__,
                         VecVar& vars__, std::ostream* pstream__ = nullptr) const {
    using local_scalar_t__ = double;
    stan::io::deserializer<local_scalar_t__> in__(params_r__, params_i__);
    stan::io::serializer<local_scalar_t__> out__(vars__);
    int current_statement__ = 0;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    try {
      int pos__ = std::numeric_limits<int>::min();
      pos__ = 1;
      Eigen::Matrix<local_scalar_t__,-1,1> mu =
        Eigen::Matrix<local_scalar_t__,-1,1>::Constant(SIZE, DUMMY_VAR__);
      current_statement__ = 1;
      stan::model::assign(mu,
        in__.read<Eigen::Matrix<local_scalar_t__,-1,1>>(SIZE),
        "assigning variable mu");
      out__.write(mu);
      Eigen::Matrix<local_scalar_t__,-1,1> uvs =
        Eigen::Matrix<local_scalar_t__,-1,1>::Constant(SIZE, DUMMY_VAR__);
      current_statement__ = 2;
      stan::model::assign(uvs,
        in__.read<Eigen::Matrix<local_scalar_t__,-1,1>>(SIZE),
        "assigning variable uvs");
      out__.write_free_lub(0, 1, uvs);
      Eigen::Matrix<local_scalar_t__,-1,1> nvs =
        Eigen::Matrix<local_scalar_t__,-1,1>::Constant(SIZE, DUMMY_VAR__);
      current_statement__ = 3;
      stan::model::assign(nvs,
        in__.read<Eigen::Matrix<local_scalar_t__,-1,1>>(SIZE),
        "assigning variable nvs");
      out__.write(nvs);
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
  }
  template <typename VecVar, stan::require_vector_t<VecVar>* = nullptr>
  inline void
  transform_inits_impl(const stan::io::var_context& context__, VecVar&
                       vars__, std::ostream* pstream__ = nullptr) const {
    using local_scalar_t__ = double;
    stan::io::serializer<local_scalar_t__> out__(vars__);
    int current_statement__ = 0;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    try {
      current_statement__ = 1;
      context__.validate_dims("parameter initialization", "mu", "double",
        std::vector<size_t>{static_cast<size_t>(SIZE)});
      current_statement__ = 2;
      context__.validate_dims("parameter initialization", "uvs", "double",
        std::vector<size_t>{static_cast<size_t>(SIZE)});
      current_statement__ = 3;
      context__.validate_dims("parameter initialization", "nvs", "double",
        std::vector<size_t>{static_cast<size_t>(SIZE)});
      int pos__ = std::numeric_limits<int>::min();
      pos__ = 1;
      Eigen::Matrix<local_scalar_t__,-1,1> mu =
        Eigen::Matrix<local_scalar_t__,-1,1>::Constant(SIZE, DUMMY_VAR__);
      {
        std::vector<local_scalar_t__> mu_flat__;
        current_statement__ = 1;
        mu_flat__ = context__.vals_r("mu");
        current_statement__ = 1;
        pos__ = 1;
        current_statement__ = 1;
        for (int sym1__ = 1; sym1__ <= SIZE; ++sym1__) {
          current_statement__ = 1;
          stan::model::assign(mu, mu_flat__[(pos__ - 1)],
            "assigning variable mu", stan::model::index_uni(sym1__));
          current_statement__ = 1;
          pos__ = (pos__ + 1);
        }
      }
      out__.write(mu);
      Eigen::Matrix<local_scalar_t__,-1,1> uvs =
        Eigen::Matrix<local_scalar_t__,-1,1>::Constant(SIZE, DUMMY_VAR__);
      {
        std::vector<local_scalar_t__> uvs_flat__;
        current_statement__ = 2;
        uvs_flat__ = context__.vals_r("uvs");
        current_statement__ = 2;
        pos__ = 1;
        current_statement__ = 2;
        for (int sym1__ = 1; sym1__ <= SIZE; ++sym1__) {
          current_statement__ = 2;
          stan::model::assign(uvs, uvs_flat__[(pos__ - 1)],
            "assigning variable uvs", stan::model::index_uni(sym1__));
          current_statement__ = 2;
          pos__ = (pos__ + 1);
        }
      }
      out__.write_free_lub(0, 1, uvs);
      Eigen::Matrix<local_scalar_t__,-1,1> nvs =
        Eigen::Matrix<local_scalar_t__,-1,1>::Constant(SIZE, DUMMY_VAR__);
      {
        std::vector<local_scalar_t__> nvs_flat__;
        current_statement__ = 3;
        nvs_flat__ = context__.vals_r("nvs");
        current_statement__ = 3;
        pos__ = 1;
        current_statement__ = 3;
        for (int sym1__ = 1; sym1__ <= SIZE; ++sym1__) {
          current_statement__ = 3;
          stan::model::assign(nvs, nvs_flat__[(pos__ - 1)],
            "assigning variable nvs", stan::model::index_uni(sym1__));
          current_statement__ = 3;
          pos__ = (pos__ + 1);
        }
      }
      out__.write(nvs);
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
  }
  inline void
  get_param_names(std::vector<std::string>& names__, const bool
                  emit_transformed_parameters__ = true, const bool
                  emit_generated_quantities__ = true) const {
    names__ = std::vector<std::string>{"mu", "uvs", "nvs"};
    if (emit_transformed_parameters__) {
      std::vector<std::string> temp{"vs"};
      names__.reserve(names__.size() + temp.size());
      names__.insert(names__.end(), temp.begin(), temp.end());
    }
    if (emit_generated_quantities__) {
      std::vector<std::string> temp{"log_lik"};
      names__.reserve(names__.size() + temp.size());
      names__.insert(names__.end(), temp.begin(), temp.end());
    }
  }
  inline void
  get_dims(std::vector<std::vector<size_t>>& dimss__, const bool
           emit_transformed_parameters__ = true, const bool
           emit_generated_quantities__ = true) const {
    dimss__ = std::vector<std::vector<size_t>>{std::vector<size_t>{static_cast<
                                                                    size_t>(
                                                                    SIZE)},
                std::vector<size_t>{static_cast<size_t>(SIZE)},
                std::vector<size_t>{static_cast<size_t>(SIZE)}};
    if (emit_transformed_parameters__) {
      std::vector<std::vector<size_t>>
        temp{std::vector<size_t>{static_cast<size_t>(SIZE)}};
      dimss__.reserve(dimss__.size() + temp.size());
      dimss__.insert(dimss__.end(), temp.begin(), temp.end());
    }
    if (emit_generated_quantities__) {
      std::vector<std::vector<size_t>>
        temp{std::vector<size_t>{static_cast<size_t>(SIZE)}};
      dimss__.reserve(dimss__.size() + temp.size());
      dimss__.insert(dimss__.end(), temp.begin(), temp.end());
    }
  }
  inline void
  constrained_param_names(std::vector<std::string>& param_names__, bool
                          emit_transformed_parameters__ = true, bool
                          emit_generated_quantities__ = true) const final {
    for (int sym1__ = 1; sym1__ <= SIZE; ++sym1__) {
      param_names__.emplace_back(std::string() + "mu" + '.' +
        std::to_string(sym1__));
    }
    for (int sym1__ = 1; sym1__ <= SIZE; ++sym1__) {
      param_names__.emplace_back(std::string() + "uvs" + '.' +
        std::to_string(sym1__));
    }
    for (int sym1__ = 1; sym1__ <= SIZE; ++sym1__) {
      param_names__.emplace_back(std::string() + "nvs" + '.' +
        std::to_string(sym1__));
    }
    if (emit_transformed_parameters__) {
      for (int sym1__ = 1; sym1__ <= SIZE; ++sym1__) {
        param_names__.emplace_back(std::string() + "vs" + '.' +
          std::to_string(sym1__));
      }
    }
    if (emit_generated_quantities__) {
      for (int sym1__ = 1; sym1__ <= SIZE; ++sym1__) {
        param_names__.emplace_back(std::string() + "log_lik" + '.' +
          std::to_string(sym1__));
      }
    }
  }
  inline void
  unconstrained_param_names(std::vector<std::string>& param_names__, bool
                            emit_transformed_parameters__ = true, bool
                            emit_generated_quantities__ = true) const final {
    for (int sym1__ = 1; sym1__ <= SIZE; ++sym1__) {
      param_names__.emplace_back(std::string() + "mu" + '.' +
        std::to_string(sym1__));
    }
    for (int sym1__ = 1; sym1__ <= SIZE; ++sym1__) {
      param_names__.emplace_back(std::string() + "uvs" + '.' +
        std::to_string(sym1__));
    }
    for (int sym1__ = 1; sym1__ <= SIZE; ++sym1__) {
      param_names__.emplace_back(std::string() + "nvs" + '.' +
        std::to_string(sym1__));
    }
    if (emit_transformed_parameters__) {
      for (int sym1__ = 1; sym1__ <= SIZE; ++sym1__) {
        param_names__.emplace_back(std::string() + "vs" + '.' +
          std::to_string(sym1__));
      }
    }
    if (emit_generated_quantities__) {
      for (int sym1__ = 1; sym1__ <= SIZE; ++sym1__) {
        param_names__.emplace_back(std::string() + "log_lik" + '.' +
          std::to_string(sym1__));
      }
    }
  }
  inline std::string get_constrained_sizedtypes() const {
    return std::string("[{\"name\":\"mu\",\"type\":{\"name\":\"vector\",\"length\":" + std::to_string(SIZE) + "},\"block\":\"parameters\"},{\"name\":\"uvs\",\"type\":{\"name\":\"vector\",\"length\":" + std::to_string(SIZE) + "},\"block\":\"parameters\"},{\"name\":\"nvs\",\"type\":{\"name\":\"vector\",\"length\":" + std::to_string(SIZE) + "},\"block\":\"parameters\"},{\"name\":\"vs\",\"type\":{\"name\":\"vector\",\"length\":" + std::to_string(SIZE) + "},\"block\":\"transformed_parameters\"},{\"name\":\"log_lik\",\"type\":{\"name\":\"vector\",\"length\":" + std::to_string(SIZE) + "},\"block\":\"generated_quantities\"}]");
  }
  inline std::string get_unconstrained_sizedtypes() const {
    return std::string("[{\"name\":\"mu\",\"type\":{\"name\":\"vector\",\"length\":" + std::to_string(SIZE) + "},\"block\":\"parameters\"},{\"name\":\"uvs\",\"type\":{\"name\":\"vector\",\"length\":" + std::to_string(SIZE) + "},\"block\":\"parameters\"},{\"name\":\"nvs\",\"type\":{\"name\":\"vector\",\"length\":" + std::to_string(SIZE) + "},\"block\":\"parameters\"},{\"name\":\"vs\",\"type\":{\"name\":\"vector\",\"length\":" + std::to_string(SIZE) + "},\"block\":\"transformed_parameters\"},{\"name\":\"log_lik\",\"type\":{\"name\":\"vector\",\"length\":" + std::to_string(SIZE) + "},\"block\":\"generated_quantities\"}]");
  }
  // Begin method overload boilerplate
  template <typename RNG> inline void
  write_array(RNG& base_rng, Eigen::Matrix<double,-1,1>& params_r,
              Eigen::Matrix<double,-1,1>& vars, const bool
              emit_transformed_parameters = true, const bool
              emit_generated_quantities = true, std::ostream*
              pstream = nullptr) const {
    const size_t num_params__ = ((SIZE + SIZE) + SIZE);
    const size_t num_transformed = emit_transformed_parameters * (SIZE);
    const size_t num_gen_quantities = emit_generated_quantities * (SIZE);
    const size_t num_to_write = num_params__ + num_transformed +
      num_gen_quantities;
    std::vector<int> params_i;
    vars = Eigen::Matrix<double,-1,1>::Constant(num_to_write,
             std::numeric_limits<double>::quiet_NaN());
    write_array_impl(base_rng, params_r, params_i, vars,
      emit_transformed_parameters, emit_generated_quantities, pstream);
  }
  template <typename RNG> inline void
  write_array(RNG& base_rng, std::vector<double>& params_r, std::vector<int>&
              params_i, std::vector<double>& vars, bool
              emit_transformed_parameters = true, bool
              emit_generated_quantities = true, std::ostream*
              pstream = nullptr) const {
    const size_t num_params__ = ((SIZE + SIZE) + SIZE);
    const size_t num_transformed = emit_transformed_parameters * (SIZE);
    const size_t num_gen_quantities = emit_generated_quantities * (SIZE);
    const size_t num_to_write = num_params__ + num_transformed +
      num_gen_quantities;
    vars = std::vector<double>(num_to_write,
             std::numeric_limits<double>::quiet_NaN());
    write_array_impl(base_rng, params_r, params_i, vars,
      emit_transformed_parameters, emit_generated_quantities, pstream);
  }
  template <bool propto__, bool jacobian__, typename T_> inline T_
  log_prob(Eigen::Matrix<T_,-1,1>& params_r, std::ostream* pstream = nullptr) const {
    Eigen::Matrix<int,-1,1> params_i;
    return log_prob_impl<propto__, jacobian__>(params_r, params_i, pstream);
  }
  template <bool propto__, bool jacobian__, typename T_> inline T_
  log_prob(std::vector<T_>& params_r, std::vector<int>& params_i,
           std::ostream* pstream = nullptr) const {
    return log_prob_impl<propto__, jacobian__>(params_r, params_i, pstream);
  }
  inline void
  transform_inits(const stan::io::var_context& context,
                  Eigen::Matrix<double,-1,1>& params_r, std::ostream*
                  pstream = nullptr) const final {
    std::vector<double> params_r_vec(params_r.size());
    std::vector<int> params_i;
    transform_inits(context, params_i, params_r_vec, pstream);
    params_r = Eigen::Map<Eigen::Matrix<double,-1,1>>(params_r_vec.data(),
                 params_r_vec.size());
  }
  inline void
  transform_inits(const stan::io::var_context& context, std::vector<int>&
                  params_i, std::vector<double>& vars, std::ostream*
                  pstream__ = nullptr) const {
    vars.resize(num_params_r__);
    transform_inits_impl(context, vars, pstream__);
  }
  inline void
  unconstrain_array(const std::vector<double>& params_constrained,
                    std::vector<double>& params_unconstrained, std::ostream*
                    pstream = nullptr) const {
    const std::vector<int> params_i;
    params_unconstrained = std::vector<double>(num_params_r__,
                             std::numeric_limits<double>::quiet_NaN());
    unconstrain_array_impl(params_constrained, params_i,
      params_unconstrained, pstream);
  }
  inline void
  unconstrain_array(const Eigen::Matrix<double,-1,1>& params_constrained,
                    Eigen::Matrix<double,-1,1>& params_unconstrained,
                    std::ostream* pstream = nullptr) const {
    const std::vector<int> params_i;
    params_unconstrained = Eigen::Matrix<double,-1,1>::Constant(num_params_r__,
                             std::numeric_limits<double>::quiet_NaN());
    unconstrain_array_impl(params_constrained, params_i,
      params_unconstrained, pstream);
  }
};
}
using stan_model = model_fs_namespace::model_fs;
#ifndef USING_R
// Boilerplate
stan::model::model_base&
new_model(stan::io::var_context& data_context, unsigned int seed,
          std::ostream* msg_stream) {
  stan_model* m = new stan_model(data_context, seed, msg_stream);
  return *m;
}
stan::math::profile_map& get_stan_profile_data() {
  return model_fs_namespace::profiles__;
}
#endif
#endif
